
void _evas_3d_camera_projection_matrix_set(Eo *obj, Evas_3D_Camera_Data *pd, const Evas_Real *matrix);

EOAPI EO_VOID_FUNC_BODYV(evas_3d_camera_projection_matrix_set, EO_FUNC_CALL(matrix), const Evas_Real *matrix);

void _evas_3d_camera_projection_matrix_get(Eo *obj, Evas_3D_Camera_Data *pd, Evas_Real *matrix);

EOAPI EO_VOID_FUNC_BODYV(evas_3d_camera_projection_matrix_get, EO_FUNC_CALL(matrix), Evas_Real *matrix);

void _evas_3d_camera_projection_perspective_set(Eo *obj, Evas_3D_Camera_Data *pd, Evas_Real fovy, Evas_Real aspect, Evas_Real dnear, Evas_Real dfar);

EOAPI EO_VOID_FUNC_BODYV(evas_3d_camera_projection_perspective_set, EO_FUNC_CALL(fovy, aspect, dnear, dfar), Evas_Real fovy, Evas_Real aspect, Evas_Real dnear, Evas_Real dfar);

void _evas_3d_camera_projection_frustum_set(Eo *obj, Evas_3D_Camera_Data *pd, Evas_Real left, Evas_Real right, Evas_Real bottom, Evas_Real top, Evas_Real dnear, Evas_Real dfar);

EOAPI EO_VOID_FUNC_BODYV(evas_3d_camera_projection_frustum_set, EO_FUNC_CALL(left, right, bottom, top, dnear, dfar), Evas_Real left, Evas_Real right, Evas_Real bottom, Evas_Real top, Evas_Real dnear, Evas_Real dfar);

void _evas_3d_camera_projection_ortho_set(Eo *obj, Evas_3D_Camera_Data *pd, Evas_Real left, Evas_Real right, Evas_Real bottom, Evas_Real top, Evas_Real dnear, Evas_Real dfar);

EOAPI EO_VOID_FUNC_BODYV(evas_3d_camera_projection_ortho_set, EO_FUNC_CALL(left, right, bottom, top, dnear, dfar), Evas_Real left, Evas_Real right, Evas_Real bottom, Evas_Real top, Evas_Real dnear, Evas_Real dfar);

Eina_Bool _evas_3d_camera_node_visible_get(Eo *obj, Evas_3D_Camera_Data *pd, Evas_3D_Node *camera_node, Evas_3D_Node *node, Evas_3D_Frustum_Mode key);

EOAPI EO_FUNC_BODYV(evas_3d_camera_node_visible_get, Eina_Bool, 0, EO_FUNC_CALL(camera_node, node, key), Evas_3D_Node *camera_node, Evas_3D_Node *node, Evas_3D_Frustum_Mode key);

void _evas_3d_camera_eo_base_constructor(Eo *obj, Evas_3D_Camera_Data *pd);


void _evas_3d_camera_eo_base_destructor(Eo *obj, Evas_3D_Camera_Data *pd);


void _evas_3d_camera_evas_3d_object_update_notify(Eo *obj, Evas_3D_Camera_Data *pd);


void _evas_3d_camera_evas_3d_object_change_notify(Eo *obj, Evas_3D_Camera_Data *pd, Evas_3D_State state, Evas_3D_Object *ref);


static Eo_Op_Description _evas_3d_camera_op_desc[] = {
     EO_OP_FUNC_OVERRIDE(eo_constructor, _evas_3d_camera_eo_base_constructor),
     EO_OP_FUNC_OVERRIDE(eo_destructor, _evas_3d_camera_eo_base_destructor),
     EO_OP_FUNC_OVERRIDE(evas_3d_object_update_notify, _evas_3d_camera_evas_3d_object_update_notify),
     EO_OP_FUNC_OVERRIDE(evas_3d_object_change_notify, _evas_3d_camera_evas_3d_object_change_notify),
     EO_OP_FUNC(evas_3d_camera_projection_matrix_set, _evas_3d_camera_projection_matrix_set, "Set the projection matrix of the given camera."),
     EO_OP_FUNC(evas_3d_camera_projection_matrix_get, _evas_3d_camera_projection_matrix_get, "Get the projection matrix of the given camera."),
     EO_OP_FUNC(evas_3d_camera_projection_perspective_set, _evas_3d_camera_projection_perspective_set, "Set the projection matrix of the given camera with perspective projection."),
     EO_OP_FUNC(evas_3d_camera_projection_frustum_set, _evas_3d_camera_projection_frustum_set, "Set the projection matrix of the given camera with frustum projection."),
     EO_OP_FUNC(evas_3d_camera_projection_ortho_set, _evas_3d_camera_projection_ortho_set, "Set the projection matrix of the given camera with orthogonal projection."),
     EO_OP_FUNC(evas_3d_camera_node_visible_get, _evas_3d_camera_node_visible_get, "Check is bounding sphere of given node inside frustum of camera node."),
     EO_OP_SENTINEL
};

static const Eo_Class_Description _evas_3d_camera_class_desc = {
     EO_VERSION,
     "Evas_3D_Camera",
     EO_CLASS_TYPE_REGULAR,
     EO_CLASS_DESCRIPTION_OPS(_evas_3d_camera_op_desc),
     NULL,
     sizeof(Evas_3D_Camera_Data),
     NULL,
     NULL
};

EO_DEFINE_CLASS(evas_3d_camera_class_get, &_evas_3d_camera_class_desc, EVAS_3D_OBJECT_CLASS, EVAS_COMMON_INTERFACE_INTERFACE, NULL);