
void _evas_grid_mirrored_set(Eo *obj, Evas_Grid_Data *pd, Eina_Bool mirrored);

EOAPI EO_VOID_FUNC_BODYV(evas_obj_grid_mirrored_set, EO_FUNC_CALL(mirrored), Eina_Bool mirrored);

Eina_Bool _evas_grid_mirrored_get(Eo *obj, Evas_Grid_Data *pd);

EOAPI EO_FUNC_BODY(evas_obj_grid_mirrored_get, Eina_Bool, 0);

void _evas_grid_size_set(Eo *obj, Evas_Grid_Data *pd, int w, int h);

EOAPI EO_VOID_FUNC_BODYV(evas_obj_grid_size_set, EO_FUNC_CALL(w, h), int w, int h);

void _evas_grid_size_get(Eo *obj, Evas_Grid_Data *pd, int *w, int *h);

EOAPI EO_VOID_FUNC_BODYV(evas_obj_grid_size_get, EO_FUNC_CALL(w, h), int *w, int *h);

Eina_List * _evas_grid_children_get(Eo *obj, Evas_Grid_Data *pd);

EOAPI EO_FUNC_BODY(evas_obj_grid_children_get, Eina_List *, 0);

Eina_Accessor * _evas_grid_accessor_new(Eo *obj, Evas_Grid_Data *pd);

EOAPI EO_FUNC_BODY(evas_obj_grid_accessor_new, Eina_Accessor *, 0);

void _evas_grid_clear(Eo *obj, Evas_Grid_Data *pd, Eina_Bool clear);

EOAPI EO_VOID_FUNC_BODYV(evas_obj_grid_clear, EO_FUNC_CALL(clear), Eina_Bool clear);

Eina_Iterator * _evas_grid_iterator_new(Eo *obj, Evas_Grid_Data *pd);

EOAPI EO_FUNC_BODY(evas_obj_grid_iterator_new, Eina_Iterator *, 0);

Evas_Object * _evas_grid_add_to(Eo *obj, Evas_Grid_Data *pd);

EOAPI EO_FUNC_BODY(evas_obj_grid_add_to, Evas_Object *, 0);

Eina_Bool _evas_grid_unpack(Eo *obj, Evas_Grid_Data *pd, Evas_Object *child);

EOAPI EO_FUNC_BODYV(evas_obj_grid_unpack, Eina_Bool, 0, EO_FUNC_CALL(child), Evas_Object *child);

Eina_Bool _evas_grid_pack_get(Eo *obj, Evas_Grid_Data *pd, Evas_Object *child, int *x, int *y, int *w, int *h);

EOAPI EO_FUNC_BODYV(evas_obj_grid_pack_get, Eina_Bool, 0, EO_FUNC_CALL(child, x, y, w, h), Evas_Object *child, int *x, int *y, int *w, int *h);

Eina_Bool _evas_grid_pack(Eo *obj, Evas_Grid_Data *pd, Evas_Object *child, int x, int y, int w, int h);

EOAPI EO_FUNC_BODYV(evas_obj_grid_pack, Eina_Bool, 0, EO_FUNC_CALL(child, x, y, w, h), Evas_Object *child, int x, int y, int w, int h);

void _evas_grid_eo_base_constructor(Eo *obj, Evas_Grid_Data *pd);


static Eo_Op_Description _evas_grid_op_desc[] = {
     EO_OP_FUNC_OVERRIDE(eo_constructor, _evas_grid_eo_base_constructor),
     EO_OP_FUNC(evas_obj_grid_mirrored_set, _evas_grid_mirrored_set, "Sets the mirrored mode of the grid. In mirrored mode the grid items go"),
     EO_OP_FUNC(evas_obj_grid_mirrored_get, _evas_grid_mirrored_get, "Gets the mirrored mode of the grid."),
     EO_OP_FUNC(evas_obj_grid_size_set, _evas_grid_size_set, "Set the virtual resolution for the grid"),
     EO_OP_FUNC(evas_obj_grid_size_get, _evas_grid_size_get, "Get the current virtual resolution"),
     EO_OP_FUNC(evas_obj_grid_children_get, _evas_grid_children_get, "Get the list of children for the grid."),
     EO_OP_FUNC(evas_obj_grid_accessor_new, _evas_grid_accessor_new, "Get an accessor to get random access to the list of children for the grid."),
     EO_OP_FUNC(evas_obj_grid_clear, _evas_grid_clear, "Faster way to remove all child objects from a grid object."),
     EO_OP_FUNC(evas_obj_grid_iterator_new, _evas_grid_iterator_new, "Get an iterator to walk the list of children for the grid."),
     EO_OP_FUNC(evas_obj_grid_add_to, _evas_grid_add_to, "Create a grid that is child of a given element @a parent."),
     EO_OP_FUNC(evas_obj_grid_unpack, _evas_grid_unpack, "Remove child from grid."),
     EO_OP_FUNC(evas_obj_grid_pack_get, _evas_grid_pack_get, "Get the pack options for a grid child"),
     EO_OP_FUNC(evas_obj_grid_pack, _evas_grid_pack, "Add a new child to a grid object."),
     EO_OP_SENTINEL
};

static const Eo_Class_Description _evas_grid_class_desc = {
     EO_VERSION,
     "Evas_Grid",
     EO_CLASS_TYPE_REGULAR,
     EO_CLASS_DESCRIPTION_OPS(_evas_grid_op_desc),
     NULL,
     sizeof(Evas_Grid_Data),
     NULL,
     NULL
};

EO_DEFINE_CLASS(evas_grid_class_get, &_evas_grid_class_desc, EVAS_SMART_CLIPPED_CLASS, NULL);
EAPI void
evas_object_grid_mirrored_set(Evas_Grid *obj, Eina_Bool mirrored)
{
   eo_do((Evas_Grid *)obj, evas_obj_grid_mirrored_set(mirrored));
}

EAPI Eina_Bool
evas_object_grid_mirrored_get(const Evas_Grid *obj)
{
   return eo_do((Evas_Grid *)obj, evas_obj_grid_mirrored_get());
}

EAPI void
evas_object_grid_size_set(Evas_Grid *obj, int w, int h)
{
   eo_do((Evas_Grid *)obj, evas_obj_grid_size_set(w, h));
}

EAPI void
evas_object_grid_size_get(const Evas_Grid *obj, int *w, int *h)
{
   eo_do((Evas_Grid *)obj, evas_obj_grid_size_get(w, h));
}

EAPI Eina_List *
evas_object_grid_children_get(const Evas_Grid *obj)
{
   return eo_do((Evas_Grid *)obj, evas_obj_grid_children_get());
}

EAPI Eina_Accessor *
evas_object_grid_accessor_new(const Evas_Grid *obj)
{
   return eo_do((Evas_Grid *)obj, evas_obj_grid_accessor_new());
}

EAPI void
evas_object_grid_clear(Evas_Grid *obj, Eina_Bool clear)
{
   eo_do((Evas_Grid *)obj, evas_obj_grid_clear(clear));
}

EAPI Eina_Iterator *
evas_object_grid_iterator_new(const Evas_Grid *obj)
{
   return eo_do((Evas_Grid *)obj, evas_obj_grid_iterator_new());
}

EAPI Evas_Object *
evas_object_grid_add_to(Evas_Grid *obj)
{
   return eo_do((Evas_Grid *)obj, evas_obj_grid_add_to());
}

EAPI Eina_Bool
evas_object_grid_unpack(Evas_Grid *obj, Evas_Object *child)
{
   return eo_do((Evas_Grid *)obj, evas_obj_grid_unpack(child));
}

EAPI Eina_Bool
evas_object_grid_pack_get(const Evas_Grid *obj, Evas_Object *child, int *x, int *y, int *w, int *h)
{
   return eo_do((Evas_Grid *)obj, evas_obj_grid_pack_get(child, x, y, w, h));
}

EAPI Eina_Bool
evas_object_grid_pack(Evas_Grid *obj, Evas_Object *child, int x, int y, int w, int h)
{
   return eo_do((Evas_Grid *)obj, evas_obj_grid_pack(child, x, y, w, h));
}
